Index: palm/trunk/SOURCE/Makefile
===================================================================
--- palm/trunk/SOURCE/Makefile	(revision 3636)
+++ palm/trunk/SOURCE/Makefile	(revision 3637)
@@ -25,4 +25,7 @@
 # -----------------
 # $Id$
+# Implementation of the PALM module interface
+# 
+# 3634 2018-12-18 12:31:28Z knoop
 # OpenACC port for SPEC
 # 
@@ -623,4 +626,5 @@
 	bulk_cloud_model_mod.f90 \
 	model_1d_mod.f90 \
+	module_interface.f90 \
 	mod_kinds.f90 \
 	mod_particle_attributes.f90 \
@@ -785,18 +789,10 @@
 	modules.o
 average_3d_data.o: \
-	biometeorology_mod.o \
-	bulk_cloud_model_mod.o \
-	chemistry_model_mod.o \
 	cpulog_mod.o \
 	exchange_horiz_2d.o \
-	gust_mod.o \
-	land_surface_model_mod.o \
-	mod_kinds.o \
-	modules.o \
-	ocean_mod.o \
-	radiation_model_mod.o \
-	salsa_mod.o \
-	turbulence_closure_mod.o \
-	urban_surface_mod.o
+	mod_kinds.o \
+	module_interface.o \
+	modules.o \
+	turbulence_closure_mod.o
 basic_constants_and_equations_mod.o: \
 	mod_kinds.o
@@ -843,31 +839,17 @@
 check_parameters.o: \
 	basic_constants_and_equations_mod.o \
-	biometeorology_mod.o \
-	bulk_cloud_model_mod.o \
 	chemistry_model_mod.o \
 	chem_emissions_mod.o \
-	gust_mod.o \
 	init_vertical_profiles.o \
-	land_surface_model_mod.o \
-	large_scale_forcing_nudging_mod.o \
 	model_1d_mod.o \
-	mod_kinds.o \
-	modules.o \
-	nesting_offl_mod.o \
+	module_interface.o \
+	mod_kinds.o \
+	modules.o \
 	netcdf_data_input_mod.o \
 	netcdf_interface_mod.o \
-	ocean_mod.o \
-	plant_canopy_model_mod.o \
 	pmc_interface_mod.o \
-	radiation_model_mod.o \
-	salsa_mod.o \
-	spectra_mod.o \
 	subsidence_mod.o \
-	surface_output_mod.o \
-	synthetic_turbulence_generator_mod.o \
 	turbulence_closure_mod.o \
-	urban_surface_mod.o \
-	vertical_nesting_mod.o \
-	wind_turbine_model_mod.o
+	vertical_nesting_mod.o
 chem_emissions_mod.o: \
 	chem_gasphase_mod.o \
@@ -978,33 +960,25 @@
 data_output_2d.o: \
 	basic_constants_and_equations_mod.o \
-	biometeorology_mod.o \
-	bulk_cloud_model_mod.o \
-	chemistry_model_mod.o\
-	cpulog_mod.o \
-	gust_mod.o \
+	bulk_cloud_model_mod.o \
+	cpulog_mod.o \
 	land_surface_model_mod.o \
 	mod_kinds.o \
 	mod_particle_attributes.o \
-	modules.o \
-	netcdf_interface_mod.o \
-	ocean_mod.o \
-	radiation_model_mod.o \
-	salsa_mod.o \
+	module_interface.o \
+	modules.o \
+	netcdf_interface_mod.o \
 	surface_mod.o \
 	urban_surface_mod.o
 data_output_3d.o: \
 	basic_constants_and_equations_mod.o \
-	biometeorology_mod.o \
-	bulk_cloud_model_mod.o \
-	chemistry_model_mod.o \
-	cpulog_mod.o \
-	gust_mod.o \
+	bulk_cloud_model_mod.o \
+	cpulog_mod.o \
 	land_surface_model_mod.o \
 	mod_kinds.o \
 	mod_particle_attributes.o \
-	modules.o \
-	netcdf_interface_mod.o \
-	ocean_mod.o \
-	salsa_mod.o \
+	module_interface.o \
+	modules.o \
+	netcdf_interface_mod.o \
+	radiation_model_mod.o \
 	turbulence_closure_mod.o \
 	urban_surface_mod.o
@@ -1058,10 +1032,10 @@
 	basic_constants_and_equations_mod.o \
 	bulk_cloud_model_mod.o \
-	chemistry_model_mod.o \
-	cpulog_mod.o \
-	gust_mod.o \
+	chem_modules.o \
+	cpulog_mod.o \
 	land_surface_model_mod.o \
 	large_scale_forcing_nudging_mod.o \
 	mod_kinds.o \
+	module_interface.o \
 	modules.o \
 	netcdf_interface_mod.o \
@@ -1076,27 +1050,18 @@
 header.o: \
 	basic_constants_and_equations_mod.o \
-	biometeorology_mod.o \
-	bulk_cloud_model_mod.o \
-	chemistry_model_mod.o \
+	bulk_cloud_model_mod.o \
 	cpulog_mod.o \
 	date_and_time_mod.o \
-	gust_mod.o \
-	land_surface_model_mod.o \
-	large_scale_forcing_nudging_mod.o \
 	model_1d_mod.o \
-	mod_kinds.o \
-	modules.o \
-	netcdf_interface_mod.o \
-	nesting_offl_mod.o \
+	module_interface.o \
+	mod_kinds.o \
+	modules.o \
+	netcdf_interface_mod.o \
 	ocean_mod.o \
 	plant_canopy_model_mod.o \
 	pmc_handle_communicator_mod.o \
 	pmc_interface_mod.o \
-	radiation_model_mod.o \
-	salsa_mod.o \
-	spectra_mod.o \
 	subsidence_mod.o \
-	surface_mod.o \
-	virtual_flight_mod.o
+	surface_mod.o
 indoor_model_mod.o: \
 	cpulog_mod.o \
@@ -1355,4 +1320,29 @@
 	modules.o \
 	time_to_string.o
+module_interface.o: \
+	mod_kinds.o \
+	modules.o \
+	biometeorology_mod.o \
+	bulk_cloud_model_mod.o \
+	chemistry_model_mod.o \
+	gust_mod.o \
+	indoor_model_mod.o \
+	land_surface_model_mod.o \
+	large_scale_forcing_nudging_mod.o \
+	multi_agent_system_mod.o \
+	nesting_offl_mod.o \
+	ocean_mod.o \
+	plant_canopy_model_mod.o \
+	radiation_model_mod.o \
+	salsa_mod.o \
+	spectra_mod.o \
+	surface_output_mod.o \
+	synthetic_turbulence_generator_mod.o \
+	urban_surface_mod.o \
+	user_read_restart_data_mod.o \
+	user_write_restart_data_mod.o \
+	virtual_flight_mod.o \
+	virtual_measurement_mod.o \
+	wind_turbine_model_mod.o
 modules.o: \
 	mod_kinds.o
@@ -1436,34 +1426,16 @@
 	write_restart_data_mod.o
 parin.o: \
-	biometeorology_mod.o \
-	bulk_cloud_model_mod.o \
-	chemistry_model_mod.o \
 	chem_modules.o \
 	cpulog_mod.o \
 	date_and_time_mod.o \
-	gust_mod.o \
-	indoor_model_mod.o \
-	land_surface_model_mod.o \
 	model_1d_mod.o \
 	mod_kinds.o \
 	modules.o \
-	multi_agent_system_mod.o \
-	nesting_offl_mod.o \
-	netcdf_interface_mod.o \
-	ocean_mod.o \
-	plant_canopy_model_mod.o \
+	netcdf_interface_mod.o \
 	pmc_interface_mod.o \
 	progress_bar_mod.o \
-	radiation_model_mod.o \
 	read_restart_data_mod.o \
-	salsa_mod.o \
-	spectra_mod.o \
-	surface_output_mod.o \
-	synthetic_turbulence_generator_mod.o \
 	turbulence_closure_mod.o \
-	vertical_nesting_mod.o \
-	virtual_flight_mod.o \
-	virtual_measurement_mod.o \
-	wind_turbine_model_mod.o
+	vertical_nesting_mod.o
 plant_canopy_model_mod.o: \
 	bulk_cloud_model_mod.o \
@@ -1601,26 +1573,18 @@
 	modules.o
 read_restart_data_mod.o: \
-	bulk_cloud_model_mod.o \
-	chemistry_model_mod.o \
+	chem_modules.o \
 	cpulog_mod.o \
 	date_and_time_mod.o \
-	gust_mod.o \
-	land_surface_model_mod.o \
-	modules.o \
 	mod_kinds.o \
 	model_1d_mod.o \
+	module_interface.o \
+	modules.o \
 	netcdf_interface_mod.o \
 	radiation_model_mod.o \
 	random_function_mod.o\
 	random_generator_parallel_mod.o \
-	salsa_mod.o \
 	spectra_mod.o \
 	surface_mod.o \
-	synthetic_turbulence_generator_mod.o \
-	urban_surface_mod.o \
-	user_read_restart_data_mod.o \
-	vertical_nesting_mod.o \
-	virtual_flight_mod.o \
-	wind_turbine_model_mod.o
+	vertical_nesting_mod.o
 run_control.o: \
 	cpulog_mod.o \
@@ -1661,14 +1625,9 @@
 sum_up_3d_data.o: \
 	basic_constants_and_equations_mod.o \
-	biometeorology_mod.o \
-	bulk_cloud_model_mod.o \
-	chemistry_model_mod.o \
-	cpulog_mod.o \
-	gust_mod.o \
-	land_surface_model_mod.o \
-	mod_kinds.o \
-	modules.o \
-	radiation_model_mod.o \
-	salsa_mod.o \
+	bulk_cloud_model_mod.o \
+	cpulog_mod.o \
+	mod_kinds.o \
+	module_interface.o \
+	modules.o \
 	surface_mod.o \
 	turbulence_closure_mod.o \
@@ -1700,16 +1659,10 @@
 	surface_mod.o
 swap_timelevel.o: \
-	bulk_cloud_model_mod.o \
-	chemistry_model_mod.o \
-	cpulog_mod.o \
-	gust_mod.o \
-	land_surface_model_mod.o \
-	mod_kinds.o \
-	modules.o \
-	ocean_mod.o \
+	cpulog_mod.o \
+	mod_kinds.o \
+	module_interface.o \
+	modules.o \
 	pmc_interface_mod.o \
-	salsa_mod.o \
-	turbulence_closure_mod.o \
-	urban_surface_mod.o
+	turbulence_closure_mod.o
 synthetic_turbulence_generator_mod.o: \
 	basic_constants_and_equations_mod.o \
@@ -1992,23 +1945,15 @@
 	mod_kinds.o
 write_restart_data_mod.o: \
-	bulk_cloud_model_mod.o \
-	chemistry_model_mod.o \
 	date_and_time_mod.o \
-	gust_mod.o \
-	land_surface_model_mod.o \
 	mod_kinds.o \
 	mod_particle_attributes.o \
 	model_1d_mod.o \
-	modules.o \
-	netcdf_interface_mod.o \
-	ocean_mod.o \
+	module_interface.o \
+	modules.o \
+	netcdf_interface_mod.o \
 	radiation_model_mod.o \
 	random_function_mod.o \
 	random_generator_parallel_mod.o \
-	spectra_mod.o surface_mod.o \
-	synthetic_turbulence_generator_mod.o \
-	urban_surface_mod.o \
-	user_write_restart_data_mod.o \
-	vertical_nesting_mod.o \
-	virtual_flight_mod.o \
-	wind_turbine_model_mod.o
+	spectra_mod.o \
+	surface_mod.o \
+	vertical_nesting_mod.o
Index: palm/trunk/SOURCE/average_3d_data.f90
===================================================================
--- palm/trunk/SOURCE/average_3d_data.f90	(revision 3636)
+++ palm/trunk/SOURCE/average_3d_data.f90	(revision 3637)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Implementation of the PALM module interface
+! 
+! 3597 2018-12-04 08:40:18Z maronga
 ! Added theta_2m
 ! 
@@ -173,23 +176,10 @@
     USE averaging
 
-    USE biometeorology_mod,                                                    &
-        ONLY:  bio_3d_data_averaging
-
-    USE bulk_cloud_model_mod,                                                  &
-        ONLY:  bulk_cloud_model, bcm_3d_data_averaging
-
-    USE chemistry_model_mod,                                                   &
-        ONLY:  chem_3d_data_averaging
-
     USE control_parameters,                                                    &
-        ONLY:  air_chemistry, average_count_3d, biometeorology, doav, doav_n,  &
-               land_surface, ocean_mode, salsa, urban_surface, varnamelength
+        ONLY:  average_count_3d, doav, doav_n, varnamelength
 
     USE cpulog,                                                                &
         ONLY:  cpu_log, log_point
 
-    USE gust_mod,                                                              &
-        ONLY:  gust_3d_data_averaging, gust_module_enabled
-
     USE indices,                                                               &
         ONLY:  nbgp, nxl, nxlg, nxr, nxrg, nyn, nyng, nys, nysg, nzb, nzt
@@ -197,21 +187,9 @@
     USE kinds
 
-    USE land_surface_model_mod,                                                &
-        ONLY:  lsm_3d_data_averaging
-
-    USE ocean_mod,                                                             &
-        ONLY:  ocean_3d_data_averaging
-
-    USE radiation_model_mod,                                                   &
-        ONLY:  radiation, radiation_3d_data_averaging
-           
-    USE salsa_mod,                                                             &
-        ONLY:  salsa_3d_data_averaging 
+    USE module_interface,                                                      &
+        ONLY:  module_interface_3d_data_averaging
 
     USE turbulence_closure_mod,                                                &
         ONLY:  tcm_3d_data_averaging
-
-    USE urban_surface_mod,                                                     &
-        ONLY:  usm_average_3d_data
 
 
@@ -573,48 +551,11 @@
 
           CASE DEFAULT
-!
-!--          Averaging of data from other modules
-             IF ( air_chemistry .AND. &
-                  (trimvar(1:3) == 'kc_' .OR. trimvar(1:3) == 'em_')  )  THEN
-                CALL chem_3d_data_averaging( 'average', doav(ii) )
-             ENDIF
-
-             IF ( bulk_cloud_model )  THEN
-                CALL bcm_3d_data_averaging( 'average', doav(ii) )
-             ENDIF
-
-             IF ( gust_module_enabled )  THEN
-                CALL gust_3d_data_averaging( 'average', doav(ii) )
-             ENDIF
-
-             IF ( land_surface )  THEN
-                CALL lsm_3d_data_averaging( 'average', doav(ii) )
-             ENDIF
-
-             IF ( ocean_mode )  THEN
-                CALL ocean_3d_data_averaging( 'average', doav(ii) )
-             ENDIF
-
-             IF ( radiation )  THEN
-                CALL radiation_3d_data_averaging( 'average', doav(ii) )
-             ENDIF
-             
-             IF ( salsa )  THEN
-                CALL salsa_3d_data_averaging( 'average', doav(ii) )
-             ENDIF             
-
-             IF ( biometeorology )  THEN
-                CALL bio_3d_data_averaging( 'average', doav(ii) )
-             ENDIF
-
-             CALL tcm_3d_data_averaging( 'average', doav(ii) )
-
-             IF ( urban_surface  .AND.  trimvar(1:4) == 'usm_' )  THEN
-                CALL usm_average_3d_data( 'average', doav(ii) )
-             ENDIF
-
-!
-!--          User-defined quantities
-             CALL user_3d_data_averaging( 'average', doav(ii) )
+
+!
+!--          Averaging of data from turbulence closure module
+             CALL tcm_3d_data_averaging( 'average', trimvar )
+!
+!--          Averaging of data from all other modules
+             CALL module_interface_3d_data_averaging( 'average', trimvar )
 
        END SELECT
Index: palm/trunk/SOURCE/check_parameters.f90
===================================================================
--- palm/trunk/SOURCE/check_parameters.f90	(revision 3636)
+++ palm/trunk/SOURCE/check_parameters.f90	(revision 3637)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Implementation of the PALM module interface
+! 
+! 3597 2018-12-04 08:40:18Z maronga
 ! Added checks for theta_2m
 ! 
@@ -748,19 +751,11 @@
     USE basic_constants_and_equations_mod
 
-    USE biometeorology_mod,                                                    &
-        ONLY:  bio_check_data_output, bio_check_parameters
-
     USE bulk_cloud_model_mod,                                                  &
-        ONLY:  bulk_cloud_model, bcm_check_parameters, bcm_check_data_output,  &
-               bcm_check_data_output_pr
-
-    USE chem_emissions_mod,                                                    &
-        ONLY:  chem_emissions_check_parameters
+        ONLY:  bulk_cloud_model
 
     USE chem_modules
 
     USE chemistry_model_mod,                                                   &
-        ONLY:  chem_boundary_conds, chem_check_data_output,                    &
-               chem_check_data_output_pr, chem_check_parameters, chem_species
+        ONLY:  chem_boundary_conds
 
     USE control_parameters
@@ -770,25 +765,16 @@
     USE grid_variables
 
-    USE gust_mod,                                                              &
-        ONLY: gust_check_data_output, gust_check_data_output_pr,               &
-              gust_check_parameters, gust_module_enabled
-
     USE kinds
 
     USE indices
-
-    USE land_surface_model_mod,                                                &
-        ONLY: lsm_check_data_output, lsm_check_data_output_pr,                 &
-              lsm_check_parameters
-
-    USE lsf_nudging_mod,                                                       &
-        ONLY:  lsf_nudging_check_parameters, lsf_nudging_check_data_output_pr
 
     USE model_1d_mod,                                                          &
         ONLY:  damp_level_1d, damp_level_ind_1d
 
-    USE nesting_offl_mod,                                                      &
-        ONLY:  nesting_offl_check_parameters
-        
+    USE module_interface,                                                      &
+        ONLY:  module_interface_check_parameters,                              &
+               module_interface_check_data_output_pr,                          &
+               module_interface_check_data_output
+
     USE netcdf_data_input_mod,                                                 &
         ONLY:  init_model, input_pids_static, netcdf_data_input_check_dynamic, &
@@ -800,14 +786,7 @@
                waterflux_output_unit, momentumflux_output_unit
 
-    USE ocean_mod,                                                             &
-        ONLY:  ocean_check_data_output, ocean_check_data_output_pr,            &
-               ocean_check_parameters
-
     USE particle_attributes
 
     USE pegrid
-
-    USE plant_canopy_model_mod,                                                &
-        ONLY:  pcm_check_data_output, pcm_check_parameters
 
     USE pmc_interface,                                                         &
@@ -816,37 +795,17 @@
     USE profil_parameter
 
-    USE radiation_model_mod,                                                   &
-        ONLY:  radiation, radiation_check_data_output,                         &
-               radiation_check_data_output_pr, radiation_check_parameters
-                            
-    USE salsa_mod,                                                             &
-        ONLY:  salsa_check_data_output, salsa_check_parameters        
-
-    USE spectra_mod,                                                           &
-        ONLY:  calculate_spectra, spectra_check_parameters
-
     USE statistics
 
     USE subsidence_mod
 
-    USE surface_output_mod,                                                    &
-        ONLY:  surface_output_check_parameters
-
-    USE synthetic_turbulence_generator_mod,                                    &
-        ONLY:  stg_check_parameters
-
     USE transpose_indices
 
     USE turbulence_closure_mod,                                                &
-        ONLY:  tcm_check_data_output, tcm_check_parameters
-
-    USE urban_surface_mod,                                                     &
-        ONLY:  usm_check_data_output, usm_check_parameters
-
-    USE wind_turbine_model_mod,                                                &
-        ONLY:  wtm_check_parameters
+        ONLY:  tcm_check_parameters,                                           &
+               tcm_check_data_output
 
     USE vertical_nesting_mod,                                                  &
-        ONLY:  vnested, vnest_check_parameters
+        ONLY:  vnested,                                                        &
+               vnest_check_parameters
 
 
@@ -1525,30 +1484,9 @@
 
 !
-!-- Check the module settings:
-!-- tcm_check_parameters must be called at first
+!-- tcm_check_parameters must be called before all other module calls
     CALL tcm_check_parameters
 
-    IF ( biometeorology )       CALL bio_check_parameters
-    IF ( bulk_cloud_model )     CALL bcm_check_parameters
-    IF ( air_chemistry )        CALL chem_check_parameters
-!   IF ( air_chemistry )        CALL chem_emissions_check_parameters   ! forkel preliminary
-    IF ( gust_module_enabled )  CALL gust_check_parameters
-    IF ( large_scale_forcing  .OR.  nudging )                                  &
-                                CALL lsf_nudging_check_parameters
-    IF ( land_surface )         CALL lsm_check_parameters
-    IF ( nesting_offline )      CALL nesting_offl_check_parameters    
-    IF ( ocean_mode )           CALL ocean_check_parameters
-    IF ( plant_canopy )         CALL pcm_check_parameters
-    IF ( radiation )            CALL radiation_check_parameters
-    IF ( calculate_spectra )    CALL spectra_check_parameters
-                                CALL stg_check_parameters
-    IF ( urban_surface )        CALL usm_check_parameters
-    IF ( wind_turbine )         CALL wtm_check_parameters
-!
-!-- Checks for surface data output
-    IF ( surface_data_output )  CALL surface_output_check_parameters
-!    
-!-- When SALSA is used, perform additional checks 
-    IF ( salsa )  CALL salsa_check_parameters     
+!-- Check the module settings
+    CALL module_interface_check_parameters
 
 !
@@ -1562,14 +1500,5 @@
        IF ( humidity       )  q_init  = q_surface
        IF ( passive_scalar )  s_init  = s_surface
-!
-!--    TODO
-!--    Russo: Is done in chem_init and would overwrite what is done there
-!--    --> kanani: Revise
-!      IF ( air_chemistry )  THEN
-!        DO lsp = 1, nvar
-!           chem_species(lsp)%conc_pr_init = cs_surface(lsp)      
-!        ENDDO
-!      ENDIF
-!
+
 !--
 !--    If required, compute initial profile of the geostrophic wind
@@ -2960,44 +2889,6 @@
 !
 !--          Check for other modules
-             IF ( unit == 'illegal' .AND.  bulk_cloud_model )  THEN
-                CALL bcm_check_data_output_pr( data_output_pr(i), i, unit,     &
-                                               dopr_unit(i) )
-             ENDIF
-
-             IF ( unit == 'illegal' .AND.  air_chemistry )  THEN
-                CALL chem_check_data_output_pr( data_output_pr(i), i, unit,    &
-                                                dopr_unit(i) )
-             ENDIF
-
-             IF ( unit == 'illegal'  .AND.  gust_module_enabled  )  THEN
-                CALL gust_check_data_output_pr( data_output_pr(i), i, unit,    &
-                                                dopr_unit(i) )
-             ENDIF
-
-             IF ( unit == 'illegal' )  THEN
-                CALL lsf_nudging_check_data_output_pr( data_output_pr(i), i,   &
-                                                       unit, dopr_unit(i) )
-             ENDIF
-
-             IF ( unit == 'illegal' )  THEN
-                CALL lsm_check_data_output_pr( data_output_pr(i), i, unit,        &
-                                            dopr_unit(i) )
-             ENDIF
-             IF ( unit == 'illegal' )  THEN
-                CALL ocean_check_data_output_pr( data_output_pr(i), i, unit,   &
-                                                 dopr_unit(i) )
-             ENDIF
-
-             IF ( unit == 'illegal' )  THEN
-                CALL radiation_check_data_output_pr( data_output_pr(i), i,     &
-                                                     unit, dopr_unit(i) )
-             ENDIF
-
-!
-!--          Finally, check for user defined quantities
-             IF ( unit == 'illegal' )  THEN
-                unit = ''
-                CALL user_check_data_output_pr( data_output_pr(i), i, unit )
-             ENDIF
+             CALL module_interface_check_data_output_pr( data_output_pr(i), i, &
+                                                         unit, dopr_unit(i) )
 
 !
@@ -3224,55 +3115,7 @@
 
              CALL tcm_check_data_output( var, unit )
-
 !
 !--          Check for other modules
-             IF ( unit == 'illegal'  .AND.  bulk_cloud_model  )  THEN
-                CALL bcm_check_data_output( var, unit )
-             ENDIF
-
-             IF ( unit == 'illegal'  .AND.  air_chemistry                      &
-                  .AND.  (var(1:3) == 'kc_' .OR. var(1:3) == 'em_') )  THEN
-                CALL chem_check_data_output( var, unit, i, ilen, k )
-             ENDIF
-
-             IF ( unit == 'illegal' )  THEN
-                CALL lsm_check_data_output ( var, unit, i, ilen, k )
-             ENDIF
-
-             IF ( unit == 'illegal'  .AND.  gust_module_enabled  )  THEN
-                CALL gust_check_data_output ( var, unit )
-             ENDIF
-
-             IF ( unit == 'illegal'  .AND.  biometeorology )  THEN
-                CALL bio_check_data_output( var, unit, i, ilen, k )
-             ENDIF
-
-             IF ( unit == 'illegal'  .AND.  ocean_mode )  THEN
-                CALL ocean_check_data_output( var, unit )
-             ENDIF
-
-             IF ( unit == 'illegal'  .AND.  plant_canopy                       &
-                                     .AND.  var(1:4) == 'pcm_' )  THEN
-                CALL pcm_check_data_output( var, unit )
-             ENDIF
-
-             IF ( unit == 'illegal' )  THEN
-                CALL radiation_check_data_output( var, unit, i, ilen, k )
-             ENDIF
-
-             IF ( unit == 'illegal' .AND. salsa ) THEN
-                 CALL salsa_check_data_output( var, unit )
-             ENDIF   
-
-             IF ( unit == 'illegal'  .AND.  urban_surface                      &
-                                     .AND.  var(1:4) == 'usm_' )  THEN
-                 CALL usm_check_data_output( var, unit )
-             ENDIF
-!
-!--          Finally, check for user-defined quantities
-             IF ( unit == 'illegal' )  THEN
-                unit = ''
-                CALL user_check_data_output( var, unit )
-             ENDIF
+             CALL module_interface_check_data_output( var, unit, i, ilen, k )
 
              IF ( unit == 'illegal' )  THEN
@@ -3986,7 +3829,4 @@
 
     CALL location_message( 'finished', .TRUE. )
-!
-!-- Check &userpar parameters
-    CALL user_check_parameters
 
  CONTAINS
Index: palm/trunk/SOURCE/chemistry_model_mod.f90
===================================================================
--- palm/trunk/SOURCE/chemistry_model_mod.f90	(revision 3636)
+++ palm/trunk/SOURCE/chemistry_model_mod.f90	(revision 3637)
@@ -27,4 +27,7 @@
 ! -----------------
 ! $Id$
+! Implementation of the PALM module interface
+! 
+! 3636 2018-12-19 13:48:34Z raasch
 ! nopointer option removed
 !
@@ -588,4 +591,5 @@
     INTEGER(iwp) :: lsp                 !< running index for chem spcs
 
+    IF ( (variable(1:3) == 'kc_' .OR. variable(1:3) == 'em_')  )  THEN
 
     IF ( mode == 'allocate' )  THEN
@@ -662,4 +666,6 @@
           ENDIF
        ENDDO
+
+    ENDIF
 
     ENDIF
Index: palm/trunk/SOURCE/data_output_2d.f90
===================================================================
--- palm/trunk/SOURCE/data_output_2d.f90	(revision 3636)
+++ palm/trunk/SOURCE/data_output_2d.f90	(revision 3637)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Implementation of the PALM module interface
+! 
+! 3597 2018-12-04 08:40:18Z maronga
 ! Added theta_2m
 ! 
@@ -284,29 +287,20 @@
         ONLY:  c_p, lv_d_cp, l_v
 
-    USE biometeorology_mod,                                                    &
-        ONLY:  bio_data_output_2d
-
     USE bulk_cloud_model_mod,                                                  &
-        ONLY:  bulk_cloud_model, bcm_data_output_2d
-
-    USE chemistry_model_mod,                                                   &
-        ONLY:  chem_data_output_2d
+        ONLY:  bulk_cloud_model
 
     USE control_parameters,                                                    &
-        ONLY:  air_chemistry, biometeorology, data_output_2d_on_each_pe,       &
+        ONLY:  data_output_2d_on_each_pe,                                      &
                data_output_xy, data_output_xz, data_output_yz, do2d,           &
                do2d_xy_last_time, do2d_xy_time_count,                          &
                do2d_xz_last_time, do2d_xz_time_count,                          &
                do2d_yz_last_time, do2d_yz_time_count,                          &
-               ibc_uv_b, io_blocks, io_group, land_surface, message_string,    &
+               ibc_uv_b, io_blocks, io_group, message_string,                  &
                ntdim_2d_xy, ntdim_2d_xz, ntdim_2d_yz,                          &
-               ocean_mode, psolver, salsa, section, simulated_time,            &
+               psolver, section, simulated_time,                               &
                time_since_reference_point
 
     USE cpulog,                                                                &
-        ONLY:  cpu_log, log_point 
-        
-    USE gust_mod,                                                              &
-        ONLY:  gust_data_output_2d, gust_module_enabled
+        ONLY:  cpu_log, log_point
 
     USE indices,                                                               &
@@ -317,5 +311,8 @@
 
     USE land_surface_model_mod,                                                &
-        ONLY:  lsm_data_output_2d, zs
+        ONLY:  zs
+
+    USE module_interface,                                                      &
+        ONLY:  module_interface_data_output_2d
 
 #if defined( __netcdf )
@@ -327,7 +324,4 @@
                id_var_time_xy, id_var_time_xz, id_var_time_yz, nc_stat,        &
                netcdf_data_format, netcdf_handle_error
-
-    USE ocean_mod,                                                             &
-        ONLY:  ocean_data_output_2d
 
     USE particle_attributes,                                                   &
@@ -336,10 +330,4 @@
     
     USE pegrid
-
-    USE radiation_model_mod,                                                   &
-        ONLY:  radiation, radiation_data_output_2d
-   
-    USE salsa_mod,                                                             &
-        ONLY:  salsa_data_output_2d    
 
     USE surface_mod,                                                           &
@@ -1362,50 +1350,10 @@
 !
 !--             Quantities of other modules
-                IF ( .NOT. found  .AND.  bulk_cloud_model )  THEN
-                   CALL bcm_data_output_2d( av, do2d(av,ivar), found, grid, mode,&
-                                            local_pf, two_d, nzb_do, nzt_do )
-                ENDIF
-
-                IF ( .NOT. found  .AND.  gust_module_enabled )  THEN
-                   CALL gust_data_output_2d( av, do2d(av,ivar), found, grid,     &
-                                             local_pf, two_d, nzb_do, nzt_do )
-                ENDIF
-
-                IF ( .NOT. found  .AND.  biometeorology )  THEN
-                   CALL bio_data_output_2d( av, do2d(av,ivar), found, grid,      &
-                                            local_pf, two_d, nzb_do, nzt_do )
-                ENDIF
-
-                IF ( .NOT. found  .AND.  land_surface )  THEN
-                   CALL lsm_data_output_2d( av, do2d(av,ivar), found, grid, mode,&
-                                            local_pf, two_d, nzb_do, nzt_do )
-                ENDIF
-
-                IF ( .NOT. found  .AND.  ocean_mode )  THEN
-                   CALL ocean_data_output_2d( av, do2d(av,ivar), found, grid,    &
-                                              mode, local_pf, nzb_do, nzt_do )
-                ENDIF
-
-                IF ( .NOT. found  .AND.  radiation )  THEN
-                   CALL radiation_data_output_2d( av, do2d(av,ivar), found, grid,&
-                                                  mode, local_pf, two_d,       &
-                                                  nzb_do, nzt_do  )
-                ENDIF
-                
-                IF ( .NOT. found  .AND.  salsa )  THEN
-                   CALL salsa_data_output_2d( av, do2d(av,ivar), found, grid,  &
-                                              mode, local_pf, two_d, nzb_do,   &
-                                              nzt_do)
-                ENDIF                 
-
-                IF ( .NOT. found  .AND.  air_chemistry )  THEN
-                   CALL chem_data_output_2d( av, do2d(av,ivar), found, grid, mode, &
-                                             local_pf, two_d, nzb_do, nzt_do, fill_value )
-                ENDIF
-!
-!--             User defined quantities
                 IF ( .NOT. found )  THEN
-                   CALL user_data_output_2d( av, do2d(av,ivar), found, grid,     &
-                                             local_pf, two_d, nzb_do, nzt_do )
+                   CALL module_interface_data_output_2d(                       &
+                           av, do2d(av,ivar), found, grid, mode,               &
+                           local_pf, two_d, nzb_do, nzt_do,                    &
+                           fill_value                                          &
+                        )
                 ENDIF
 
